HDU 5113 Black And White(DFS)

Black And White

Time Limit: 2000/2000 MS (Java/Others)    Memory Limit: 512000/512000 K (Java/Others)
Total Submission(s): 4934    Accepted Submission(s): 1334
Special Judge


Problem Description
In mathematics, the four color theorem, or the four color map theorem, states that, given any separation of a plane into contiguous regions, producing a figure called a map, no more than four colors are required to color the regions of the map so that no two adjacent regions have the same color.
— Wikipedia, the free encyclopedia

In this problem, you have to solve the 4-color problem. Hey, I’m just joking.

You are asked to solve a similar problem:

Color an N × M chessboard with K colors numbered from 1 to K such that no two adjacent cells have the same color (two cells are adjacent if they share an edge). The i-th color should be used in exactly c i cells.

Matt hopes you can tell him a possible coloring.
 

Input
The first line contains only one integer T (1 ≤ T ≤ 5000), which indicates the number of test cases.

For each test case, the first line contains three integers: N, M, K (0 < N, M ≤ 5, 0 < K ≤ N × M ).

The second line contains K integers c i (c i > 0), denoting the number of cells where the i-th color should be used.

It’s guaranteed that c 1 + c 2 + · · · + c K = N × M .
 

Output
For each test case, the first line contains “Case #x:”, where x is the case number (starting from 1). 

In the second line, output “NO” if there is no coloring satisfying the requirements. Otherwise, output “YES” in one line. Each of the following N lines contains M numbers seperated by single whitespace, denoting the color of the cells.

If there are multiple solutions, output any of them.
 

Sample Input
  
  
4 1 5 2 4 1 3 3 4 1 2 2 4 2 3 3 2 2 2 3 2 3 2 2 2
 

Sample Output
  
  
Case #1: NO Case #2: YES 4 3 4 2 1 2 4 3 4 Case #3: YES 1 2 3 2 3 1 Case #4: YES 1 2 2 3 3 1
 

Source


【思路】

可以看到数据非常小,所以我们可以直接暴力做这道题目,从上往下、从左往右填每个格子即可。可以剪枝的情况:先对剩下的格子像国际象棋棋盘那样黑白分块,任何一种颜色剩下的颜料只可按照黑块或白块那么填,所以不会多于空白块的一半,故可剪去未来必定填错的情况。


【代码】

#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

const int MAXN = 30;

int t, n, m, k;
int c[MAXN];
int mp[MAXN][MAXN];
bool flag;

bool ok(int x, int y)
{
    return (1 <= x && x <= n && 1 <= y && y <= m);
}

void dfs(int x, int y)
{
    if (x > n) {flag = true; return;}
    int remain = m * n - ((x - 1) * m + y - 1);
    for (int i = 1; i <= k; i++)
        if ((remain + 1) / 2 < c[i]) return;
    for (int i = 1; i <= k && !flag; i++) {
        if (c[i] == 0) continue;
        if (ok(x - 1, y) && mp[x - 1][y] == i || ok(x, y - 1) && mp[x][y - 1] == i) continue;
        c[i]--;
        mp[x][y] = i;
        if (y + 1 <= m)
            dfs(x, y + 1);
        else
            dfs(x + 1, 1);
        c[i]++;
    }
}

int main()
{
    scanf("%d", &t);
    for (int kase = 1; kase <= t; kase++) {
        scanf("%d %d %d", &n, &m, &k);
        for (int i = 1; i <= k; i++) scanf("%d", &c[i]);
        flag = false;
        dfs(1, 1);
        if (!flag)
            printf("Case #%d:\nNO\n", kase);
        else {
            printf("Case #%d:\nYES\n", kase);
            for (int i = 1; i <= n; i++) {
                for (int j = 1; j <= m; j++) {
                    printf("%d", mp[i][j]);
                    if (j != m) printf(" ");
                }
                printf("\n");
            }
        }
    }
    return 0;
}



  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值